'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-2a6e6244.js');
const index_esm_min = require('./index.esm.min-596e4656.js');

const bpSdkCreateAppFormButtonCss = ":host{display:block}";

let BpSdkCreateAppFormButton = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    /**
     * Text to be displayed
     */
    this.text = '';
    /**
     * Id for button
     */
    this.buttonId = index_esm_min.fx(8);
    /**
     * Controls disables state of button
     */
    this.buttonDisabled = false;
    this.useExternal = false;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-create-app-form-button');
    customElements.whenDefined('bp-sdk-external-create-app-form-button').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return index.h("bp-sdk-external-create-app-form-button", { text: this.text, buttonId: this.buttonId, buttonDisabled: this.buttonDisabled });
  }
  renderInternal() {
    return index.h("bp-sdk-button", { class: "bp-sdk-create-form-button__container", text: this.text, buttonId: this.buttonId, buttonDisabled: this.buttonDisabled });
  }
};
BpSdkCreateAppFormButton.style = bpSdkCreateAppFormButtonCss;

exports.bp_sdk_create_app_form_button = BpSdkCreateAppFormButton;
