'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-2a6e6244.js');
const index_esm_min = require('./index.esm.min-5281696d.js');

const bpSdkErrorsCss = "";

let BpSdkErrors = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    /**
     * Error messages
     */
    this.errors = [];
    this.useExternal = false;
  }
  transformError(error) {
    switch (error) {
      case index_esm_min.L.MaximumValue:
      case index_esm_min.L.MinimumValue:
        if (index_esm_min.ne.includes(this.fieldType)) {
          return this.errorMessages.value(this.min, this.max);
        }
        else {
          return this.errorMessages.length(this.min, this.max);
        }
      case index_esm_min.L.MinimumDate:
      case index_esm_min.L.MaximumDate:
        return this.errorMessages.date(this.minDate, this.maxDate);
      case index_esm_min.L.Required:
        return this.errorMessages.required();
      case index_esm_min.L.Pattern:
        return this.errorMessages.pattern();
    }
    return error;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-errors');
    customElements.whenDefined('bp-sdk-external-errors').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-errors", { answerId: this.answerId, errorMessages: this.errorMessages, errors: this.errors, errorText: this.errorText, fieldType: this.fieldType, maxDate: this.maxDate, max: this.max, minDate: this.minDate, min: this.min, pattern: this.pattern, questionId: this.questionId }));
  }
  renderInternal() {
    return (index.h("div", { class: "bp-sdk-errors__container" }, this.errorText && (index.h("span", { "aria-live": "polite", id: `bp-sdk-error-${this.answerId}-text`, class: `bp-sdk-errors-text bp-sdk-errors-text-${this.answerId}` }, this.errorText)), !this.errorText && (index.h("ul", { class: "bp-sdk-errors__list" }, this.errors.map((error) => (index.h("li", { "aria-live": "polite", id: `bp-sdk-errors__${this.answerId}-${error}`, class: `bp-sdk-errors__list-item bp-sdk-errors__list-item-${this.answerId}` }, this.transformError(error))))))));
  }
};
BpSdkErrors.style = bpSdkErrorsCss;

exports.bp_sdk_errors = BpSdkErrors;
