'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-2a6e6244.js');
const sdkRedux = require('@boldpenguin/sdk-redux');
const store = require('./store-fe3d3434.js');

let BpSdkQuestionSetNavigationContainer = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.useExternal = false;
    this.questionSetList = [];
    this.isNavigationEnabled = true;
    this.handleSubscriptions = () => {
      if (store.canGetStore()) {
        this.storeUnsubscribe && this.storeUnsubscribe();
        store.store.mapDispatchToProps(this, { updateActiveQuestionSet: sdkRedux.updateActiveQuestionSet, removeActiveAnswerId: sdkRedux.removeActiveAnswerId });
        this.storeUnsubscribe = store.store.mapStateToProps(this, this.mapStateToProps);
      }
    };
    this.mapStateToProps = (state) => {
      return {
        questionSets: state.application.questionSets,
        configOptions: sdkRedux.getConfigOptions(state),
      };
    };
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
    this.handleSubscriptions();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-question-set-navigation-container');
    customElements.whenDefined('bp-sdk-external-question-set-navigation-container').then(() => {
      this.useExternal = true;
    });
    this.handleSubscriptions();
  }
  onRemoveActiveAnswerRequest() {
    this.removeActiveAnswerId();
  }
  disconnectedCallback() {
    this.storeUnsubscribe && this.storeUnsubscribe();
  }
  handleActiveQuestionSetUpdate(evt) {
    if (this.useExternal) {
      return;
    }
    evt.detail && this.updateActiveQuestionSet(evt.detail);
    this.removeActiveAnswerId();
  }
  componentWillUpdate() {
    this.handleSubscriptions();
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return index.h("bp-sdk-external-question-set-navigation-container", { configOptions: this.configOptions, questionSets: this.questionSets });
  }
  onQuestionSetsChange(sets) {
    var _a;
    this.activeId = sets === null || sets === void 0 ? void 0 : sets.active;
    this.questionSetList = (_a = sets === null || sets === void 0 ? void 0 : sets.list) !== null && _a !== void 0 ? _a : [];
  }
  onConfigOptionsChange(options) {
    var _a;
    this.isNavigationEnabled = (_a = options === null || options === void 0 ? void 0 : options.enableQuestionSetNavigation) !== null && _a !== void 0 ? _a : true;
  }
  renderInternal() {
    if (!store.canGetStore()) {
      return null;
    }
    return (index.h("bp-sdk-question-set-navigation", { activeId: this.activeId, questionSets: this.questionSetList, isNavigationEnabled: this.isNavigationEnabled }));
  }
  get el() { return index.getElement(this); }
  static get watchers() { return {
    "questionSets": ["onQuestionSetsChange"],
    "configOptions": ["onConfigOptionsChange"]
  }; }
};

exports.bp_sdk_question_set_navigation_container = BpSdkQuestionSetNavigationContainer;
