'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-2a6e6244.js');
const index_esm_min = require('./index.esm.min-596e4656.js');

const bpSdkQuoteRequestButtonCss = "";

let BpSdkQuoteRequestButton = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    /**
     * Text to be displayed
     */
    this.text = '';
    /**
     * Id for button
     */
    this.buttonId = index_esm_min.fx(8);
    /**
     * Controls disabled state of button
     */
    this.buttonDisabled = false;
    this.useExternal = false;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-quote-request-button');
    customElements.whenDefined('bp-sdk-external-quote-request-button').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return index.h("bp-sdk-external-quote-request-button", { buttonId: this.buttonId, buttonDisabled: this.buttonDisabled, text: this.text });
  }
  renderInternal() {
    return (index.h("bp-sdk-button", { class: "bp-sdk-quote-request-button__container", text: this.text, buttonId: this.buttonId, buttonDisabled: this.buttonDisabled }));
  }
};
BpSdkQuoteRequestButton.style = bpSdkQuoteRequestButtonCss;

exports.bp_sdk_quote_request_button = BpSdkQuoteRequestButton;
