'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-2a6e6244.js');
const index_esm_min = require('./index.esm.min-596e4656.js');

const bpSdkVehicleQuestionSetButtonCss = "";

let BpSdkVehicleQuestionSetButton = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    /**
     * Text to be displayed
     */
    this.text = '';
    /**
     * Id for button
     */
    this.buttonId = index_esm_min.fx(8);
    /**
     * Controls disabled state of button
     */
    this.buttonDisabled = false;
    this.cssClasses = 'bp-sdk-vehicle-question-set-button__container';
    this.useExternal = false;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-vehicle-question-set-button');
    customElements.whenDefined('bp-sdk-external-vehicle-question-set-button').then(() => {
      this.useExternal = true;
    });
    this.calculateButtonClasses(this.extraCssClasses);
  }
  calculateButtonClasses(extraClasses = '') {
    this.cssClasses = `bp-sdk-vehicle-question-set-button__container ${extraClasses}`;
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return index.h("bp-sdk-external-vehicle-question-set-button", { text: this.text, buttonId: this.buttonId, buttonDisabled: this.buttonDisabled });
  }
  renderInternal() {
    return index.h("bp-sdk-button", { class: this.cssClasses, text: this.text, buttonId: this.buttonId, buttonDisabled: this.buttonDisabled });
  }
  static get watchers() { return {
    "extraCssClasses": ["calculateButtonClasses"]
  }; }
};
BpSdkVehicleQuestionSetButton.style = bpSdkVehicleQuestionSetButtonCss;

exports.bp_sdk_vehicle_question_set_button = BpSdkVehicleQuestionSetButton;
