import { r as registerInstance, h } from './index-b4e0290f.js';
import { L, a as ne } from './index.esm.min-f8b70f0b.js';

const bpSdkErrorsCss = "";

let BpSdkErrors = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    /**
     * Error messages
     */
    this.errors = [];
    this.useExternal = false;
  }
  transformError(error) {
    switch (error) {
      case L.MaximumValue:
      case L.MinimumValue:
        if (ne.includes(this.fieldType)) {
          return this.errorMessages.value(this.min, this.max);
        }
        else {
          return this.errorMessages.length(this.min, this.max);
        }
      case L.MinimumDate:
      case L.MaximumDate:
        return this.errorMessages.date(this.minDate, this.maxDate);
      case L.Required:
        return this.errorMessages.required();
      case L.Pattern:
        return this.errorMessages.pattern();
    }
    return error;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-errors');
    customElements.whenDefined('bp-sdk-external-errors').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (h("bp-sdk-external-errors", { answerId: this.answerId, errorMessages: this.errorMessages, errors: this.errors, errorText: this.errorText, fieldType: this.fieldType, maxDate: this.maxDate, max: this.max, minDate: this.minDate, min: this.min, pattern: this.pattern, questionId: this.questionId }));
  }
  renderInternal() {
    return (h("div", { class: "bp-sdk-errors__container" }, this.errorText && (h("span", { "aria-live": "polite", id: `bp-sdk-error-${this.answerId}-text`, class: `bp-sdk-errors-text bp-sdk-errors-text-${this.answerId}` }, this.errorText)), !this.errorText && (h("ul", { class: "bp-sdk-errors__list" }, this.errors.map((error) => (h("li", { "aria-live": "polite", id: `bp-sdk-errors__${this.answerId}-${error}`, class: `bp-sdk-errors__list-item bp-sdk-errors__list-item-${this.answerId}` }, this.transformError(error))))))));
  }
};
BpSdkErrors.style = bpSdkErrorsCss;

export { BpSdkErrors as bp_sdk_errors };
