import { r as registerInstance, h } from './index-b4e0290f.js';

const bpSdkQuoteRequestLogoCss = "";

let BpSdkQuoteRequestLogo = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.useExternal = false;
  }
  resetState() { }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-quote-request-logo');
    customElements.whenDefined('bp-sdk-external-quote-request-logo').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return h("bp-sdk-external-quote-request-logo", { logoUrl: this.logoUrl, name: this.name, showLogo: this.showLogo });
  }
  renderInternal() {
    return (h("div", { class: "bp-sdk-quote-request-logo__container" }, this.showLogo && h("img", { class: "bp-sdk-online-quote__carrier-logo bp-sdk-quote__carrier-logo", src: this.logoUrl, alt: this.name })));
  }
};
BpSdkQuoteRequestLogo.style = bpSdkQuoteRequestLogoCss;

const bpSdkQuoteRequestLogoContainerCss = "";

let BpSdkQuoteRequestLogoContainer = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.useExternal = false;
  }
  resetState() { }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-quote-request-logo-container');
    customElements.whenDefined('bp-sdk-external-quote-request-logo-container').then(() => {
      this.useExternal = true;
    });
    this.onCarrierChange(this.carrier);
    this.onCustomLogoBaseUrlChange(this.customLogoBaseUrl);
    this.onShowCustomLogoChange(this.showCustomLogo);
  }
  onCarrierChange(carrier) {
    this.name = carrier === null || carrier === void 0 ? void 0 : carrier.name;
    this.updateLogoUrl(carrier, this.customLogoBaseUrl, this.showCustomLogo);
  }
  onCustomLogoBaseUrlChange(customLogoBaseUrl) {
    this.updateLogoUrl(this.carrier, customLogoBaseUrl, this.showCustomLogo);
  }
  onShowCustomLogoChange(showCustomLogo) {
    this.updateLogoUrl(this.carrier, this.customLogoBaseUrl, showCustomLogo);
  }
  updateLogoUrl(carrier, baseUrl, showCustomLogo) {
    var _a;
    if (showCustomLogo) {
      this.logoUrl = `${baseUrl}${(_a = carrier === null || carrier === void 0 ? void 0 : carrier.name) === null || _a === void 0 ? void 0 : _a.toLowerCase()}.png`;
    }
    else {
      this.logoUrl = carrier === null || carrier === void 0 ? void 0 : carrier.logo_url;
    }
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (h("bp-sdk-external-quote-request-logo-container", { carrier: this.carrier, customLogoBaseUrl: this.customLogoBaseUrl, showLogo: this.showLogo, showCustomLogo: this.showCustomLogo }));
  }
  renderInternal() {
    return h("bp-sdk-quote-request-logo", { logoUrl: this.logoUrl, name: this.name, showLogo: this.showLogo });
  }
  static get watchers() { return {
    "carrier": ["onCarrierChange"],
    "customLogoBaseUrl": ["onCustomLogoBaseUrlChange"],
    "showCustomLogo": ["onShowCustomLogoChange"]
  }; }
};
BpSdkQuoteRequestLogoContainer.style = bpSdkQuoteRequestLogoContainerCss;

export { BpSdkQuoteRequestLogo as bp_sdk_quote_request_logo, BpSdkQuoteRequestLogoContainer as bp_sdk_quote_request_logo_container };
