/// <reference types="lodash" />
import { EventEmitter } from '../../stencil-public-runtime';
import { IAnswer, IQuestion, IDynamicInputEventContainerComponent, TAnswerValue } from '@boldpenguin/sdk-types';
export declare class BpSdkDynamicInputEventContainer implements IDynamicInputEventContainerComponent {
  SAVE_ANSWER_DEBOUNCE_MS: number;
  /**
   * Answer
   */
  answer: IAnswer;
  /**
   * Should hide label
   */
  shouldHideLabel: boolean;
  /**
   * Use select alias
   */
  useSelectAlias: boolean;
  /**
   * Show business class selector
   */
  showBusinessClassificationSelector: boolean;
  /**
   * Error messages
   */
  errors: string[] | undefined;
  /**
   * Label to use
   */
  label: string;
  /**
   *  Labels that describe group
   */
  labelledBy: string;
  updateActiveAnswerId: (params: string) => void;
  updateErrors: (params: {
    answer: IAnswer;
    errors: string[];
  }) => void;
  /**
   * *Deprecated* Use COVERAGE_REFERENCES from sdk-types
   * Reference types for coverage selection
   */
  referenceTypes: string[];
  fieldType: string;
  isCoverageType: boolean;
  labelId: string;
  isLabelledField: boolean;
  inputComponentType: string;
  _label: string;
  lastAnswer: TAnswerValue;
  touched: boolean;
  pristine: boolean;
  useExternal: boolean;
  isDropdown: boolean;
  isNumeric: boolean;
  _errors: string[];
  hasPendingUpdate: boolean;
  el: HTMLElement;
  answerId: string;
  /**
   * Passes information needed to update answer
   */
  saveAnswer: EventEmitter<{
    answer: IAnswer;
    new_value: string | string[];
  }>;
  /**
   * Remove active answer
   */
  removeActiveAnswer: EventEmitter<void>;
  resetState(): void;
  connectedCallback(): void;
  onAnswerChange(answer: IAnswer): void;
  onHideLabelChange(shouldHideLabel: boolean): void;
  onLabelChange(label: string): void;
  updateLabel(question: IQuestion, label: string, shouldHideLabel: boolean): void;
  onErrorsChange(errors: string[], oldErrors: string[]): void;
  onTouchedChange(touched: boolean, oldValue: boolean): void;
  onPristineChange(pristine: boolean, oldValue: boolean): void;
  determineErrors(errors: string[], touched: boolean, pristine: boolean): void;
  updateErrorState(answer: IAnswer): void;
  onMakeDirty(): void;
  makeDirty(): void;
  onValueUpdate(event: CustomEvent<string | string[]>): void;
  emitSaveAnswer(newValue: string | string[]): void;
  debouncedEmit: import("lodash").DebouncedFunc<(newValue: string | string[]) => void>;
  unique(keys: string[]): string[];
  cleanValue(value: string | string[]): string | string[];
  save(data: string | string[]): void;
  updateValue(data: string | string[]): void;
  onUseExternalChange(useExternal: boolean): void;
  loadFocusEvents(): void;
  unloadFocusEvents(): void;
  getComponentType(fieldType: string): string;
  onFocusIn: () => void;
  onFocusOut: () => void;
  componentWillLoad(): void;
  componentDidLoad(): void;
  disconnectedCallback(): void;
  render(): any[];
  renderExternal(): any;
  renderInternal(): any;
  private answeredBySource;
}
