import { IIncrementInputComponent } from '@boldpenguin/sdk-types';
export declare class BpSdkIncrementInput implements IIncrementInputComponent {
  /**
   * Answer id
   */
  answerId: string;
  /**
   * Question id
   */
  questionId: string;
  /**
   * Initial text value
   */
  text: string;
  /**
   * Aria label id's that describes input for screen readers
   */
  labelId: string;
  /**
   * Field type
   */
  fieldType: string;
  /**
   * Placeholder to display
   */
  placeholder: string;
  /**
   * Regular expression pattern input should match
   */
  pattern: string | undefined;
  /**
   * Question code
   */
  code: string;
  /**
   * Is question required
   */
  required: boolean;
  /**
   * minimum length of input
   */
  min: number;
  /**
   * maximum length of input
   */
  max: number;
  /**
   * Error messages
   */
  errors: string[];
  /**
   * Error text
   */
  errorText: string;
  /**
   * is touched
   */
  touched: boolean;
  /**
   * is pristine
   */
  pristine: boolean;
  /**
   * Is answer in complete state
   */
  isCompleted: boolean;
  /**
   * When true, the field will be readonly. It will display only the label and value as plain text.
   */
  isReadOnly: boolean;
  /**
   * Label
   */
  label: string;
  /**
   *  Labels that describe group
   */
  labelledBy: string;
  /**
   * Is enabled
   */
  isEnabled: boolean;
  /**
   * Reference type
   */
  referenceType: string;
  /**
   * Help text
   */
  helpText: string;
  /**
   * Specifically how the question was answered (ie. "ACORD 126")
   */
  answeredBySource: string | undefined;
  useExternal: boolean;
  resetState(): void;
  componentWillLoad(): void;
  render(): any[];
  renderExternal(): any;
  renderInternal(): any;
}
