import { IAnswer, IMappedQuestionGroupAnswers, IVehiclePanelComponent, IVehicleSummary } from '@boldpenguin/sdk-types';
export declare class BpSdkVehiclePanel implements IVehiclePanelComponent {
  /**
   * Code
   */
  code: string;
  /**
   * Non-vehicle specific answers
   */
  answers: IAnswer[];
  /**
   * Question Group
   */
  questionGroup: IMappedQuestionGroupAnswers;
  /**
   * Can edit
   */
  canEdit: boolean;
  /**
   * Is editing
   */
  isEditing: boolean;
  /**
   * Is expanded
   */
  isExpanded: boolean;
  /**
   * Can Delete
   */
  canDelete: boolean;
  /**
   * Can Save
   */
  canSave: boolean;
  /**
   * On close function hook
   */
  handleClose: () => void;
  /**
   * On open function hook
   */
  handleOpen: () => void;
  /**
   * On close function hook
   */
  handleDelete: () => void;
  /**
   * On open function hook
   */
  handleEdit: (e: MouseEvent) => void;
  /**
   * Is vehicle valid
   */
  isValid: boolean;
  /**
   * Vehicle information
   */
  vehicleInformation: IVehicleSummary;
  /**
   * Default "Add new vehicle" label text
   */
  vehicleLabel: string;
  /**
   * should show trailers?
   */
  shouldShowTrailers: boolean;
  /**
   * Is vehicle trailer?
   */
  isVehicleTrailer: boolean;
  useExternal: boolean;
  icon: string;
  labelledBy: string;
  ids: {
    year: string;
    make: string;
    model: string;
    slot: string;
  };
  onIsValidChange(isValid: boolean): void;
  resetState(): void;
  connectedCallback(): void;
  componentWillLoad(): void;
  onVehicleInformationChange(vehicleInformation: IVehicleSummary): void;
  render(): any[];
  renderExternal(): any;
  onClick: () => void;
  renderContent(): any;
  renderInternal(): any;
}
